const plugin = require('../');
const fs = require('fs');
const path = require('path');
const core = require('babel-core');

const f = file => path.join(__dirname, '..', '__fixtures__', file);
const read = file => fs.readFileSync(f(file), 'utf8');
const given = file => ({ source: read(`${file}.js`), target: read(`${file}-output.js`) });
const l = string => string.trim().split('\n');

test('already a class, should not change anything', () => {
    // Given
    const { source, target } = given('class-already');

    // When
    const { code } = core.transform(source, { plugins: [plugin] });

    // When
    expect(l(code)).toEqual(l(target));
});

test('function but no annotation, should not change anything', () => {
    // Given
    const { source, target } = given('export-default-param');

    // When
    const { code } = core.transform(source, { plugins: [plugin] });

    // When
    expect(l(code)).toEqual(l(target));
});

// TODO: test don't convert simple functions (no react in scope)
// TODO: test don't convert functions with multiple parameters
// TODO: test don't convert functions with non-object parameters
// TODO: test convert with function with one render function inside
// TODO: test convert functional component with separate export default
// TODO: test convert functional component with non export-default
